<?php

function startMysql()
{
    $GLOBALS['mysqli'] = new mysqli("localhost", "root", "", "auth_users");
    if ($GLOBALS['mysqli']->connect_error) {
        die("MYSQL ISSUE : " . $GLOBALS['mysqli']->connect_error);
    }

    $GLOBALS['mysqli']->set_charset("utf8");
    $GLOBALS['stmt'] = $GLOBALS['mysqli']->stmt_init();
}

function endMysql()
{
    $GLOBALS['stmt']->close();
    $GLOBALS['mysqli']->close();
}

function insertRow($data, $table, $interface = null, $where = ["keys" => "", "values" => []])
{
    startMysql();

    $keys = array_keys($data);
    $keysStr = join(",", $keys);

    $values = array_values($data);

    if ($interface == "update") {
        $keysStr = "";
        foreach ($data as $theKey => $theValue) {
            $keysStr .= "{$theKey}=?, ";
        }

        $keysStr = substr($keysStr, 0, strlen($keysStr) - 2);

        if (count($where['values'])) {
            $values = array_merge($values, $where['values']);
            $where['keys'] = " WHERE " . $where['keys'];
        }

        $query = "UPDATE `{$table}` SET {$keysStr}" . $where['keys'];
    } else if ($interface === null) {

        $valuesStrQuestion = str_repeat("? , ", count($values));

        if (1 < count($values)) {
            $valuesStrQuestion = substr($valuesStrQuestion, 0, strlen($valuesStrQuestion) - 3);
        }

        $query = "INSERT INTO `{$table}` ({$keysStr}) VALUES ({$valuesStrQuestion})";
    }

    $inserted_id = 0;
    $GLOBALS['stmt']->prepare($query);
    $GLOBALS['stmt']->bind_param(str_repeat("s", count($values)), ...$values);

    if ($GLOBALS['stmt']->execute()) {
        $inserted_id = $GLOBALS['stmt']->affected_rows;

        if ($interface === null) {
            $inserted_id = $GLOBALS['stmt']->insert_id;
        }
    }

    endMysql();

    return $inserted_id;
}

function selectRow($table, $data = [], $concat_query = "1=1")
{
    startMysql();

    $query = "SELECT * FROM `{$table}` WHERE {$concat_query}";
    $rows = [];

    $GLOBALS['stmt']->prepare($query);
    if ($data) {
        $GLOBALS['stmt']->bind_param(str_repeat("s", count($data)), ...$data);
    }

    if ($GLOBALS['stmt']->execute() && $res = $GLOBALS['stmt']->get_result()) {
        if ($GLOBALS['stmt']->affected_rows || $res->num_rows) {
            while ($row = $res->fetch_assoc()) {
                $rows[] = $row;
            }
        }
    }

    endMysql();

    return $rows;
}

function updateRow($data, $table, $where = ["keys" => "", "values" => []])
{
    $affectefRows = insertRow($data, $table, "update", $where);
    return $affectefRows;
}

function isRowExists($table, $data, $concat_query)
{
    $rows = selectRow($table, $data, $concat_query);

    if (!$rows) return false;
    else {
        return $rows[0];
    }
}
