<?php

function regexCheck($str, $regex)
{
    $str = preg_replace($regex,"", $str);
  
    return $str == "";
}

function limit_send_message($limit, $to)
{
    $can_send = 1;
    if ($limit) {
        $row = selectRow("otp", [$to, getDatetime()], "{$limit['column']}=? AND ? <= expired_at");
        if (isset($row[0])) {
            $row = $row[0];

            if (isset($limit['data']['id']) && $row['id'] != $limit['data']['id']) {
                $can_send = 0;
            } else if (!isset($limit['data']['id']) && !empty($limit['restrict'])) {
                $can_send = 0;
            }
        }
    }

    return $can_send;
}


function send_message($message, $to, $limit = ["column" => "", "data" => [], "restrict" => false])
{
    if (!empty($limit['column'])) {
        $status_limit = limit_send_message($limit, $to);
        if (!$status_limit) return $limit['column'];
    }

    $status = 0;

    $body = ["username" => 'USERNAME', "password" => 'PASSWORD', "to" => $to, "from" => 'FROM', "text" => $message, "isflash" => 'true',];
    $response = postRequest('http://api.payamak-panel.com/post/send.asmx/SendSimpleSMS', $body);

    $response = (array)new SimpleXMLElement($response);
    $response = trim($response['string']);

    if (100 < $response) $status = 1;
    else $status = 0;

    return $status;
}

function postRequest($url, $data)
{
    $params = http_build_query($data);
    $options = array(
        CURLOPT_URL => $url,
        CURLOPT_HTTPHEADER => ["Content-Type: application/x-www-form-urlencoded"],
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $params,
        CURLOPT_SSL_VERIFYPEER => false,
        CURLOPT_RETURNTRANSFER => true
    );

    $ch = curl_init();
    curl_setopt_array($ch, $options);

    $response = curl_exec($ch);

    curl_close($ch);

    return $response;
}

function getDatetime($timestamp = null)
{
    $timestamp = $timestamp ?: time();
    return date("Y-m-d H:i:s", $timestamp);
}

function generate_password_hash($password, $option = ["cost" => "10"])
{
    return password_hash($password, PASSWORD_BCRYPT, $option);
}

function check_hashed_password($password, $hashed_password)
{
    return password_verify($password, $hashed_password);
}

function get_current_user_data()
{
    if (!isset($GLOBALS['user_data']))
        $GLOBALS['user_data'] = [];

    $status = false;

    if (isset($_COOKIE['auth'])) {
        $token_data = isRowExists("session_token", [$_COOKIE['auth']], "token=?");

        $invalid_cookie_cbk = function() use ($status){
            setcookie("auth" , "" , time() - 15);
            return $status;
        };

        if (!$token_data){
            return $invalid_cookie_cbk();
        }

        if ($token_data['expired_at'] < getDatetime()) {
            return $invalid_cookie_cbk();
        }


        $GLOBALS['user_data']['phone_number'] = $token_data['phone_number'];

        if ($token_data['user_id'] < 0) {
            $GLOBALS['user_data']['need_complete_profile'] = true;
        } else {
            $user = isRowExists("users", [$token_data['user_id']], "id=?");
            if ($user) {
                $GLOBALS['user_data']['need_complete_profile'] = false;
                $GLOBALS['user_data']['username'] = $user['username'];
                $GLOBALS['user_data']['fullname'] = $user['fullname'];
                $GLOBALS['user_data']['token'] = $token_data['token'];
                $status = 1;
            }
        }
    }

    return $status;
}


function get_current_user_authorize()
{
    $isUserLoggedInNeedCompleteProfile = !empty($GLOBALS['user_data']['need_complete_profile']);
    $isUserLoggedIn = isset($GLOBALS['user_data']['username']);

   
    

    $redirect = "";

    $php_script_name = basename($_SERVER['PHP_SELF']);

    if ($isUserLoggedInNeedCompleteProfile && $php_script_name != "sign.up.complete.php") {
        $redirect = "sign.up.complete.php";
    } else if (!$isUserLoggedIn && !$isUserLoggedInNeedCompleteProfile && $php_script_name != "sign.up.php") {
        $redirect = "sign.up.php";
    } else if($isUserLoggedIn && $php_script_name != "view.php"){
        $redirect = "view.php";
    }

    
    if ($redirect) {
       
        header("Location: {$redirect}");
    }
}
